package com.ruoyi.bst.customer.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.ruoyi.bst.customer.domain.Customer;
import com.ruoyi.bst.customer.domain.CustomerQuery;
import com.ruoyi.bst.customer.domain.CustomerVO;
import com.ruoyi.common.vo.StringIntegerVO;

/**
 * 客户Mapper接口
 *
 * @author ruoyi
 * @date 2025-01-22
 */
public interface CustomerMapper
{
    /**
     * 查询客户
     *
     * @param id 客户主键
     * @return 客户
     */
    CustomerVO selectCustomerById(Long id);

    /**
     * 查询客户列表
     *
     * @param query 客户
     * @return 客户集合
     */
    List<CustomerVO> selectCustomerList(@Param("query")CustomerQuery query);

    /**
     * 新增客户
     *
     * @param customer 客户
     * @return 结果
     */
    int insertCustomer(Customer customer);

    /**
     * 修改客户
     *
     * @param customer 客户
     * @return 结果
     */
    public int updateCustomer(@Param("data") Customer customer);

    /**
     * 删除客户
     *
     * @param id 客户主键
     * @return 结果
     */
    int deleteCustomerById(Long id);

    /**
     * 批量删除客户
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteCustomerByIds(Long[] ids);

    /**
     * 查询客户数量
     * @param query
     * @return
     */
    int selectCount(@Param("query") CustomerQuery query);

    /**
     * 查询客户数量
     * @param query
     * @return
     */
    List<StringIntegerVO> selectCountGroupByStatus(@Param("query") CustomerQuery query);
}
