package com.ruoyi.bst.customer.service;

import java.util.List;

import com.ruoyi.bst.customer.domain.Customer;
import com.ruoyi.bst.customer.domain.CustomerQuery;
import com.ruoyi.bst.customer.domain.CustomerVO;
import com.ruoyi.common.vo.StringIntegerVO;

/**
 * 客户Service接口
 *
 * @author ruoyi
 * @date 2025-01-22
 */
public interface CustomerService
{
    /**
     * 查询客户
     *
     * @param id 客户主键
     * @return 客户
     */
    public CustomerVO selectCustomerById(Long id);

    /**
     * 查询客户列表
     *
     * @param customer 客户
     * @return 客户集合
     */
    public List<CustomerVO> selectCustomerList(CustomerQuery customer);

    /**
     * 新增客户
     *
     * @param customer 客户
     * @return 结果
     */
    public int insertCustomer(Customer customer);

    /**
     * 修改客户
     *
     * @param customer 客户
     * @return 结果
     */
    public int updateCustomer(Customer customer);

    /**
     * 批量删除客户
     *
     * @param ids 需要删除的客户主键集合
     * @return 结果
     */
    public int deleteCustomerByIds(Long[] ids);

    /**
     * 删除客户信息
     *
     * @param id 客户主键
     * @return 结果
     */
    public int deleteCustomerById(Long id);

    /**
     * 查询客户数量
     * @param query
     * @return
     */
    public int selectCount(CustomerQuery query);

    /**
     * 查询客户列表ByIds
     * @param ids
     * @return
     */
    List<CustomerVO> selectCustomerListByIds(List<Long> ids);

    /**
     * 查询客户数量
     * @param customerQuery
     * @return
     */
    List<StringIntegerVO> selectCountGroupByStatus(CustomerQuery customerQuery);
}
