package com.ruoyi.bst.customerFollow.domain;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 客户跟进记录对象 bst_customer_follow
 *
 * @author ruoyi
 * @date 2025-01-22
 */
@Data
public class CustomerFollow extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long followId;

    @Excel(name = "客户ID")
    @ApiModelProperty("客户ID")
    private Long customerId;

    @Excel(name = "跟进方式", readConverterExp = "1=电话,2=微信,3=见面,4=其他")
    @ApiModelProperty("跟进方式")
    private String type;

    @Excel(name = "跟进内容")
    @ApiModelProperty("跟进内容")
    private String content;

    @Excel(name = "图片")
    @ApiModelProperty("图片")
    private String picture;

    @Excel(name = "跟进人ID")
    @ApiModelProperty("跟进人ID")
    private Long userId;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "下次跟进时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("下次跟进时间")
    private Date nextFollowTime;

}
