package com.ruoyi.bst.dashboard.domain.vo;

import java.util.List;

import com.ruoyi.bst.project.domain.enums.ProjectStatus;
import com.ruoyi.common.vo.StringIntegerVO;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
public class ProjectBriefVO {

    @ApiModelProperty("项目总数")
    private Integer total;

    @ApiModelProperty("已完成")
    private Integer completed;

    @ApiModelProperty("进行中")
    private Integer inProgress;

    @ApiModelProperty("维护中")
    private Integer maintenance;

    @ApiModelProperty("开发超期")
    private Integer developmentOverdue;

    @ApiModelProperty("维护超期")
    private Integer maintenanceOverdue;

    public ProjectBriefVO(List<StringIntegerVO> statusMap) {
        this.completed = statusMap.stream()
                .filter(vo -> ProjectStatus.COMPLETED.getStatus().equals(vo.getKey()))
                .findFirst().map(StringIntegerVO::getValue).orElse(0);

        this.inProgress = statusMap.stream()
                .filter(vo -> ProjectStatus.IN_PROGRESS.getStatus().equals(vo.getKey()))
                .findFirst().map(StringIntegerVO::getValue).orElse(0);

        this.maintenance = statusMap.stream()
                .filter(vo -> ProjectStatus.MAINTENANCE.getStatus().equals(vo.getKey()))
                .findFirst().map(StringIntegerVO::getValue).orElse(0);

        this.developmentOverdue = statusMap.stream()
                .filter(vo -> ProjectStatus.DEVELOPMENT_OVERDUE.getStatus().equals(vo.getKey()))
                .findFirst().map(StringIntegerVO::getValue).orElse(0);

        this.maintenanceOverdue = statusMap.stream()
                .filter(vo -> ProjectStatus.MAINTENANCE_OVERDUE.getStatus().equals(vo.getKey()))
                .findFirst().map(StringIntegerVO::getValue).orElse(0);

        this.total = statusMap.stream().map(StringIntegerVO::getValue).reduce(0, Integer::sum);
    }
}
