package com.ruoyi.bst.dashboard.domain.vo;

import java.util.List;

import com.ruoyi.bst.task.domain.enums.TaskStatus;
import com.ruoyi.common.vo.StringIntegerVO;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
public class TaskBriefVO {

    @ApiModelProperty("任务总数")
    private Integer total;

    @ApiModelProperty("待完成")
    private Integer waitCompleted;

    @ApiModelProperty("进行中")
    private Integer inProgress;

    @ApiModelProperty("待确认")
    private Integer waitConfirm;
    
    @ApiModelProperty("已完成")
    private Integer completed;

    public TaskBriefVO(List<StringIntegerVO> statusMap) {
        this.waitCompleted = statusMap.stream()
                .filter(vo -> TaskStatus.WAIT_COMPLETED.getStatus().equals(vo.getKey()))
                .findFirst().map(StringIntegerVO::getValue).orElse(0);

        this.inProgress = statusMap.stream()
                .filter(vo -> TaskStatus.PROCESSING.getStatus().equals(vo.getKey()))
                .findFirst().map(StringIntegerVO::getValue).orElse(0);

        this.waitConfirm = statusMap.stream()
                .filter(vo -> TaskStatus.WAIT_CONFIRM.getStatus().equals(vo.getKey()))
                .findFirst().map(StringIntegerVO::getValue).orElse(0);

        this.completed = statusMap.stream()
                .filter(vo -> TaskStatus.PASS.getStatus().equals(vo.getKey()))
                .findFirst().map(StringIntegerVO::getValue).orElse(0);

        this.total = statusMap.stream().map(StringIntegerVO::getValue).reduce(0, Integer::sum);
    }
}
