package com.ruoyi.bst.dashboard.service;

import java.time.LocalDate;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ruoyi.bst.customer.domain.CustomerQuery;
import com.ruoyi.bst.customer.service.CustomerService;
import com.ruoyi.bst.dashboard.domain.vo.BriefVO;
import com.ruoyi.bst.dashboard.domain.vo.CustomerBriefVO;
import com.ruoyi.bst.dashboard.domain.vo.ProjectBriefVO;
import com.ruoyi.bst.dashboard.domain.vo.TaskBriefVO;
import com.ruoyi.bst.project.domain.ProjectQuery;
import com.ruoyi.bst.project.service.ProjectService;
import com.ruoyi.bst.task.domain.TaskQuery;
import com.ruoyi.bst.task.service.TaskService;
import com.ruoyi.common.vo.StringIntegerVO;

@Service
public class DashboardService {
    @Autowired
    private ProjectService projectService;

    @Autowired
    private TaskService taskService;

    @Autowired
    private CustomerService customerService;


    public BriefVO selectBrief() {
        BriefVO result = new BriefVO();

        // 项目概览
        List<StringIntegerVO> projectMap = projectService.selectCountGroupByStatus(new ProjectQuery());
        ProjectBriefVO projectBriefVO = new ProjectBriefVO(projectMap);
        result.setProject(projectBriefVO);

        // 任务概览
        List<StringIntegerVO> taskMap = taskService.selectCountGroupByStatus(new TaskQuery());
        TaskBriefVO taskBriefVO = new TaskBriefVO(taskMap);
        result.setTask(taskBriefVO);

        // 客户概览
        List<StringIntegerVO> customerMap = customerService.selectCountGroupByStatus(new CustomerQuery());
        CustomerBriefVO customerBriefVO = new CustomerBriefVO(customerMap);
        // 今日新增客户
        customerBriefVO.setToday(this.selectTodayCustomerCount());
        result.setCustomer(customerBriefVO);

        return result;
    }

    private int selectTodayCustomerCount() {
        CustomerQuery query = new CustomerQuery();
        query.setCreateDate(LocalDate.now());
        return customerService.selectCount(query);
    }


}
